#include "bdtypes.h"
#include "bdfunc.h"
#include "bdglobal.h"

//////////////////////////////////////////////////////////
// Globals
//////////////////////////////////////////////////////////

// Demo management
DemoState g_demostate = 
{
	NULL, // hInstance
	TRUE, // bDemoLoop
	FALSE, // MaxPriority
	FALSE, // NoSoundMode
	FALSE, // DirectSound
	FALSE, // TwoMonitors
	63,	// MidasVolume
	MusicNothing, // musicstate
	0, // hwnd
	0, // Frame
	0, 0, // BeginTick, EndTick
	0, // MIDASmodule
	0, // MIDASmodulePlayHandle
	0, // Clear color
	0, // CurrEffect
	0, // ThisTick
	0, // TickInEffect
	0, // StartOfEffect
	0, // StartOfPattern
	0, // TickInPattern
	0, // PreviousPattern
	FALSE, // AltTabQuit
	255, // fLight
	FALSE, // VideoFlo

};

// Module filename
char *g_szModulename = "history.xm";
//char *g_szModulename = "VOLCAN.XM";
char *g_szVideoModulename = "video.xm";
char *PackageName = "scorpion.pkg";
char *VideoName = "video.pkg";
// Voodoo Management
// cos and sin table
float CosTable[8192];
float SinTable[8192];
int cos_size = (sizeof(CosTable)/sizeof(float));
int sin_size = (sizeof(SinTable)/sizeof(float));
// some table for fog
GrFog_t g_FogTunnel[64];
GrFog_t g_FogCubeField[64];
GrFog_t g_FogFlaque[64];
GrFog_t g_FogRoom[64];
GrFog_t g_FogPlanes[64];
GrFog_t g_FogHomer[64];
GrFog_t g_FogPing[64];
// start and end of texture memory ( pseudo-pointers )
FxU32 g_StartTextMem, g_EndTexMem;
// A texture - frame buffer
void* g_FrameBuf3d;
// Clear color

// Textures
JpegTexture g_TextureBuff = {GR_TMU0, 0, GR_MIPMAPLEVELMASK_BOTH, 
							{GR_LOD_256, GR_LOD_256, GR_ASPECT_1x1, GR_TEXFMT_RGB_565, NULL}};
JpegTexture TEX(Buff);
JpegTexture TEX(Img1999);
JpegTexture TEX(Arf);
JpegTexture TEX(Scorpion);
JpegTexture TEX(Tunn3d);
JpegTexture TEX(Homer);
JpegTexture TEX(Mecs);
JpegTexture TEX(Glyphs);
JpegTexture TEX(Monster);
JpegTexture TEX(Demon);
JpegTexture TEX(Faerie);
JpegTexture TEX(Flotte);

JpegTexture TEX(Bigrid);
JpegTexture TEX(Earth);
JpegTexture TEX(Earth2);
JpegTexture TEX(Likid);
JpegTexture TEX(Bof);
JpegTexture TEX(Logo);
JpegTexture TEX(Ciel);
JpegTexture TEX(Ground);
JpegTexture TEX(Tourni);
JpegTexture TEX(Logo2);
JpegTexture TEX(TunnelPov);
JpegTexture TEX(Solsec);
JpegTexture TEX(Eau);
JpegTexture TEX(Rulez);
JpegTexture TEX(Fabfou);
JpegTexture TEX(Font);
JpegTexture TEX(Flo1);
JpegTexture TEX(Altf4);
JpegTexture TEX(Tour);
JpegTexture TEX(NielsShazz);
JpegTexture TEX(Volca99);
JpegTexture TEX(Ideog);
JpegTexture TEX(Dolby);
JpegTexture TEX(Hypno);
JpegTexture TEX(Flare);
JpegTexture TEX(Hypno);
JpegTexture TEX(Meta);
JpegTexture TEX(Ping);
JpegTexture TEX(Panneau);
JpegTexture TEX(Greets);
JpegTexture TEX(Flare2);
JpegTexture TEX(Flare2);
JpegTexture TEX(SolPing);
JpegTexture TEX(FlareVert);
JpegTexture TEX(Ronds);

// Pictures
Picture PIX(Glyphs);
Picture PIX(Img1999);
Picture PIX(Arf);
Picture PIX(Scorpion);
Picture PIX(Tunn3d);
Picture PIX(Homer);
Picture PIX(Mecs);
Picture PIX(Monster);
Picture PIX(Demon);
Picture PIX(Red);
Picture PIX(Faerie);
Picture PIX(Flotte);

Picture PIX(Tunnel2d);
Picture PIX(Baton3dfx);
Picture PIX(Bigrid);
Picture PIX(Earth);
Picture PIX(Earth2);
Picture PIX(Likid);
Picture PIX(Bof);
Picture PIX(Bump);
Picture PIX(Logo);
Picture PIX(Ciel);
Picture PIX(Ground);
Picture PIX(NoirBlanc);
Picture PIX(Tourni);
Picture PIX(Logo2);
Picture PIX(TunnelPov);
Picture PIX(Solsec);
Picture PIX(Eau);
Picture PIX(Rulez);
Picture PIX(Fabfou);
Picture PIX(Font);
Picture PIX(Flo1);
Picture PIX(Altf4);
Picture PIX(Tour);
Picture PIX(Font2);
Picture PIX(Xor);
Picture PIX(NielsShazz);
Picture PIX(NielsShazz2);
Picture PIX(Volca99);
Picture PIX(Ideog);
Picture PIX(Dolby);
Picture PIX(Hypno);
Picture PIX(Flare);
Picture PIX(Hypno);
Picture PIX(Meta);
Picture PIX(Ping);
Picture PIX(Panneau);
Picture PIX(Greets);
Picture PIX(Flare2);
Picture PIX(SolPing);
Picture PIX(FlareVert);
Picture PIX(Ronds);
