#include "../bdtypes.h"
#include "../bdfunc.h"
#include "../bdglobal.h"

#define FOND_Z (1.f)
static GrVertex Fond1 = {0.f,0.f,FOND_Z,  255,128,128,   0,128.f,1.f/FOND_Z,{1.f,1.f, 1.f/FOND_Z}};
static GrVertex Fond2 = {640.f,0,FOND_Z,   128,255,128,   0,128.f,1.f/FOND_Z,{255.f/FOND_Z,0,1.f/300.f}};
static GrVertex Fond3 = {640.,480.,FOND_Z,   64,64,192,   0,128.f,1.f/FOND_Z,{255.f/FOND_Z,256.f/FOND_Z,1.f/FOND_Z}};
static GrVertex Fond4 = {0,480.,FOND_Z,   64,64,192,   0,128.f,1.f/FOND_Z,{1.f,255.f/FOND_Z,1.f/FOND_Z}};

static GrVertex Fond5 = {0.f,0.f,FOND_Z,  0,0,0,   0,128.f,1.f/FOND_Z,{0.f,0.f, 1.f/FOND_Z}};
static GrVertex Fond6 = {480.f,0.f,FOND_Z,   0,0,0,   0,128.f,1.f/FOND_Z,{256.f,0.f,1.f/300.f}};
static GrVertex Fond7 = {480.f,480.f,FOND_Z,   0,0,0,   0,128.f,1.f/FOND_Z,{256.f,256.f,1.f/FOND_Z}};
static GrVertex Fond8 = {0.f,480.f,FOND_Z,   0,0,0,   0,128.f,1.f/FOND_Z,{0.f,256.f,1.f/FOND_Z}};


static int *pBumpedXR, *pBumpedYR;
static int *pBumpedXG, *pBumpedYG;
static int *pBumpedXB, *pBumpedYB;
static WORD *pTmp;

static char szEndText[] = // 32 char !!!
	"                                " // 0
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                " // 8
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                " // 16
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                " // 24
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                "
	"                                " // 32
	"   It was                       "
	"Scorpion, the demo              "
	"Released at ARF! Party 1999     "
	"by Niels (code)                 "
	"     and MalcolmZ (music)       "
	"Thanks guy for giving me this   "
	"cool tune !                     "
	"                                "
	"Some cool people:               "
	"-> Scorpion/Silicon             "
	" Master of the ScorpionMania !  "
	"-> ONC/AdrenalinePC             "
	" Cool BBS and demo guy          "
	"-> Flo                          "
	" Very good actor :-)            "
	"-> Citeweb.net                  "
	"  Here is my homepage           "
	"-> Those who are making demos   "
	"  for fun.                      "
	"                                "
	"This demo runs under Linux !!!  "
	"Use it ! Code with it !         "
	"Better spirit than commercial   "
	"things !                        "
	"                                "
	"Join Niels:                     "
	"  superfab@citeweb.net          "
	"Join MalcolmZ:                  "
	"  malcolmz@wanadoo.fr           "
	"                                "
	"################################"
	"Bon, j en ai marre d ecrire en  "
	"anglais :-))                    "
	"Une fois de plus, je suis       "
	"revenu explose d une party:     "
	"2 heures de sommeil en trois    "
	"jours c est pas terrible        "
	"                                "
	"Heureusement, cette fois j ai   "
	"pu sortir quelque chose !       "
	"                                "
	"Pub:                            "
	"  Vous cherchez un acces        "
	"Internet rapide et pas cher ?   "
	"Une solution existe !           "
	"C est le forfait DUT de l IUT.  "
	"D une duree de deux ans, il vous"
	"permettra de ramener des        "
	"centaines de Mo pour pas un rond"
	"Vous pourrez aussi jouer a      "
	"Quake tous les midis, au grand  "
	"desespoir de l administrateur   "
	"reseau.                         "
	"Faites comme moi, choisissez le "
	"DUT. Et n oubliez pas votre Zip."
	"                                "
	"Que le code soit avec toi !     "
	"Niels 28_4_1999                 "
	"                                "
	"                                "
	"                                ";

static int NbLines = (sizeof(szEndText)-1)/32;
static int NbLines2048 = (sizeof(szEndText)-1)/32*2048;
static BYTE TextGfx[(sizeof(szEndText)-1) * 8 * 8];

void LInit_Bump()
{
	int Cpt1, Cpt2, Cpt3, Cpt4;
	BYTE *pCurrCharDst;
	WORD *pCurrCharSrc;
	WORD Tmp;

	// Render the text
	for(Cpt1=0;Cpt1<NbLines;Cpt1++)
	{
		for(Cpt2=0;Cpt2<32;Cpt2++)
		{
			pCurrCharDst = &TextGfx[Cpt1*8*256+Cpt2*8];
			pCurrCharSrc = &g_PicFont2[szEndText[Cpt1*32+Cpt2]*8];
			for(Cpt3=0;Cpt3<8;Cpt3++)
			{
				for(Cpt4=0;Cpt4<8;Cpt4++)
				{
					Tmp = pCurrCharSrc[Cpt3*1024+Cpt4];
					pCurrCharDst[Cpt3*256+Cpt4] = (Tmp&31)<<3;
				}
			}
		}
	}

	pTmp =  (WORD*)malloc(sizeof(WORD)*256*256);

	// malloc tables
	pBumpedXR = (int*)malloc(sizeof(int)*256*256);
	pBumpedYR = (int*)malloc(sizeof(int)*256*256);
	pBumpedXG = (int*)malloc(sizeof(int)*256*256);
	pBumpedYG = (int*)malloc(sizeof(int)*256*256);
	pBumpedXB = (int*)malloc(sizeof(int)*256*256);
	pBumpedYB = (int*)malloc(sizeof(int)*256*256);

	// Extract BLUE
	for(Cpt1=0;Cpt1<65536;Cpt1++)
	{
		//pTmp[Cpt1] = (g_XorPic[Cpt1]&31)*8;
		pTmp[Cpt1] = (g_PicNielsShazz2[Cpt1]&31)*8;
	}

	// compute bump coords
	for(Cpt2=1;Cpt2<255;Cpt2++)
	{
		for(Cpt1=1;Cpt1<255;Cpt1++)
		{
			pBumpedXB[Cpt1+Cpt2*256] = pTmp[Cpt1-1+Cpt2*256] - pTmp[Cpt1+1+Cpt2*256];
			pBumpedYB[Cpt1+Cpt2*256] = pTmp[Cpt1+(Cpt2-1)*256] - pTmp[Cpt1+(Cpt2+1)*256];
		}
	}

	// Extract GREEN
	for(Cpt1=0;Cpt1<65536;Cpt1++)
	{
		pTmp[Cpt1] = ((g_PicBump[Cpt1]&(31<<6))>>6)*8;
	}

	for(Cpt2=1;Cpt2<255;Cpt2++)
	{
		for(Cpt1=1;Cpt1<255;Cpt1++)
		{
			pBumpedXG[Cpt1+Cpt2*256] = pTmp[Cpt1-1+Cpt2*256] - pTmp[Cpt1+1+Cpt2*256];
			pBumpedYG[Cpt1+Cpt2*256] = pTmp[Cpt1+(Cpt2-1)*256] - pTmp[Cpt1+(Cpt2+1)*256];
		}
	}

	// Extract RED
	for(Cpt1=0;Cpt1<65536;Cpt1++)
	{
		pTmp[Cpt1] = ((g_PicBump[Cpt1]&(31<<11))>>11)*8;
	}

	for(Cpt2=1;Cpt2<255;Cpt2++)
	{
		for(Cpt1=1;Cpt1<255;Cpt1++)
		{
			pBumpedXR[Cpt1+Cpt2*256] = pTmp[Cpt1-1+Cpt2*256] - pTmp[Cpt1+1+Cpt2*256];
			pBumpedYR[Cpt1+Cpt2*256] = pTmp[Cpt1+(Cpt2-1)*256] - pTmp[Cpt1+(Cpt2+1)*256];
		}
	}

	free(pTmp);

}

void QInit_Bump()
{
	grDepthBufferMode(GR_DEPTHBUFFER_DISABLE);
	grAlphaCombine(GR_COMBINE_FUNCTION_BLEND_OTHER, GR_COMBINE_FACTOR_ONE,
					GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_CONSTANT, FXFALSE);
	grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
							GR_BLEND_ONE, GR_BLEND_ZERO);
	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER,
					//GR_COMBINE_FACTOR_LOCAL,
					GR_COMBINE_FACTOR_ONE,
					GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE);
	grCullMode(GR_CULL_DISABLE);

	grChromakeyMode(GR_CHROMAKEY_DISABLE);
	grFogMode(GR_FOG_DISABLE);

	g_TextureBuff.info.format = GR_TEXFMT_INTENSITY_8;
	SelectTexture(g_TextureBuff);
}

void Effect_Bump()
{
	int Cpt1, Cpt2;
	short lx, ly;
	int PosXR, PosYR, PosXG, PosYG, PosXB, PosYB;
	int newX, newY;
	int *pX, *pY;
	BYTE *pBuffTmp;
	float Size;
	float Ptit, Gros;
	float CosXXX, SinXXX;

	BYTE *pTmp, *pTmpEnd;
	void *pBack;

	DWORD CurrLigne;

	int Img1 = g_demostate.TickInEffect/20;

	if (g_demostate.TickInEffect&1024)
		//Size = 192 + 43*(float)cos(Img1/91.f);
		Size = 150 + 43*(float)cos(Img1/91.f);
	else
		//Size = 512 + 320*cos(Img1/120.f);
		Size = 640 + 240*cos(Img1/120.f);

	Ptit = (256 - Size)/2;
	Gros = 256 - Ptit;

	CosXXX = Ptit*(float)cos(Img1/60.f);
	SinXXX = Ptit*(float)sin(Img1/52.7f);

	Fond1.tmuvtx[0].sow = (Ptit+CosXXX) / FOND_Z;
	Fond1.tmuvtx[0].tow = (Ptit+SinXXX) / FOND_Z;
	Fond2.tmuvtx[0].sow = (Gros+CosXXX) / FOND_Z;
	Fond2.tmuvtx[0].tow = (Ptit+SinXXX) / FOND_Z;
	Fond3.tmuvtx[0].sow = (Gros+CosXXX) / FOND_Z;
	Fond3.tmuvtx[0].tow = (Gros+SinXXX) / FOND_Z;
	Fond4.tmuvtx[0].sow = (Ptit+CosXXX) / FOND_Z;
	Fond4.tmuvtx[0].tow = (Gros+SinXXX) / FOND_Z;

	PosXR = (int)(127*cos(Img1/20.f) + 128);
	PosYR = (int)(127*sin(Img1/17.f) + 128);

	PosXG = (int)(50*cos(Img1/13.f) + 128);
	PosYG = (int)(60*sin(Img1/41.f) + 128);

	PosXB = (int)(60*cos(Img1/23.f) + 128);
	PosYB = (int)(100*sin(Img1/19.f) + 128);


	/*PosXR = 160.f*cos(Img1/23.f) + 128.f;
	PosYR = 160.f*sin(Img1/20.f) + 128.f;

	PosXG = 160.f*cos(Img1/23.f+2) + 128.f;
	PosYG = 160.f*sin(Img1/20.f+2) + 128.f;

	PosXB = 160.f*cos(Img1/23.f+4) + 128.f;
	PosYB = 160.f*sin(Img1/20.f+4) + 128.f;*/

	pX = pBumpedXB+256;
	pY = pBumpedYB+256;

	ly = 1 - PosYB;

	pBuffTmp = (BYTE*)g_FrameBuf3d + 257;
	for(Cpt2=1;Cpt2<255;Cpt2++)
	{
		lx = 1 - PosXB;
		for(Cpt1=1;Cpt1<255;Cpt1++)
		{	
			newX = 127-abs(*(pX++)-lx);
			if (newX<0)
				newX = 0;
			newY = 127-abs(*(pY++)-ly);
			if (newY<0)
				newY = 0;
			*(pBuffTmp++) = (newX*newY)/64;
			lx++;
		}
		pX += 2;
		pY += 2;
		pBuffTmp += 2;
		ly++;
		lx -= 254;
	}

	memset(g_FrameBuf3d, 0, 256);
	memset((char*)g_FrameBuf3d+256*255, 0, 256);

	grTexDownloadMipMap(g_TextureBuff.tmu, g_TextureBuff.start,
						g_TextureBuff.evenOdd, &g_TextureBuff.info);

	//grConstantColorValue( (128+127*cos(Img1/40.f)) + ((WORD)(128+127*cos(Img1/28.f))<<8) + ((WORD)(128+127*cos(Img1/47.f))<<16) );
	grConstantColorValue(255);

	grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ZERO,
							GR_BLEND_ONE, GR_BLEND_ZERO);
	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER,
					GR_COMBINE_FACTOR_LOCAL,
					GR_COMBINE_LOCAL_ITERATED, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

	grDrawTriangle(&Fond1, &Fond2, &Fond3);
	grDrawTriangle(&Fond3, &Fond4, &Fond1);

	CurrLigne = (g_demostate.TickInEffect/64)%(NbLines*8);

	pTmp = g_FrameBuf3d;
	pTmpEnd = (BYTE*)g_FrameBuf3d+65536;
	Cpt2=CurrLigne*256;
	while(pTmp<pTmpEnd)
	{
		if (Cpt2>=NbLines2048)
			Cpt2 = 0;
		*(pTmp++) = TextGfx[Cpt2++];
	}

	grTexDownloadMipMap(g_TextureBuff.tmu, g_TextureBuff.start,
						g_TextureBuff.evenOdd, &g_TextureBuff.info);
	SelectTexture(g_TextureBuff);

	grAlphaBlendFunction(GR_BLEND_ONE, GR_BLEND_ONE,
							GR_BLEND_ONE, GR_BLEND_ZERO);
	grColorCombine(GR_COMBINE_FUNCTION_SCALE_OTHER,
					GR_COMBINE_FACTOR_ONE,
					GR_COMBINE_LOCAL_NONE, GR_COMBINE_OTHER_TEXTURE, FXFALSE);

	grDrawTriangle(&Fond5, &Fond6, &Fond7);
	grDrawTriangle(&Fond7, &Fond8, &Fond5);
}

void ByeBye_Bump()
{


}
